package com.org.controladoralimentos;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.IBinder;
import android.support.v4.app.NotificationCompat;
import android.support.v4.app.TaskStackBuilder;


public class AlarmReceiver extends Service {
	private SQLiteHelper dbHelper;
	
	public AlarmReceiver() {
		dbHelper = new SQLiteHelper(this);
	}

	@Override
	public IBinder onBind(Intent intent) {
		// TODO: Return the communication channel to the service.
		throw new UnsupportedOperationException("Not yet implemented");
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		if(dbHelper.obtenerCaducables()){
			NotificationCompat.Builder mBuilder =
			        new NotificationCompat.Builder(this)
			        .setSmallIcon(R.drawable.ic_stat_controladoralimentos)
			        .setContentTitle("Controlador Alimentos")
			        .setTicker("Controlador Alimentos: Tiene alimentos a punto de caducar")
			        .setContentText("Tiene alimentos a punto de caducar")
			        .setDefaults(Notification.DEFAULT_VIBRATE | Notification.DEFAULT_SOUND )
			        .setLights(Color.GREEN, 2000, 1000)
			        .setAutoCancel(true);
			// Creates an explicit intent for an Activity in your app
			Intent resultIntent = new Intent(this, MainActivity.class);
			resultIntent.putExtra("notification", true);
			// The stack builder object will contain an artificial back stack for the
			// started Activity.
			// This ensures that navigating backward from the Activity leads out of
			// your application to the Home screen.
			TaskStackBuilder stackBuilder = TaskStackBuilder.create(this);
			// Adds the back stack for the Intent (but not the Intent itself)
			// Adds the Intent that starts the Activity to the top of the stack
			stackBuilder.addNextIntent(resultIntent);
			PendingIntent resultPendingIntent =
			        stackBuilder.getPendingIntent(
			            0,
			            PendingIntent.FLAG_UPDATE_CURRENT
			        );
			mBuilder.setContentIntent(resultPendingIntent);
			NotificationManager mNotificationManager =
			    (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
			// mId allows you to update the notification later on.
			
			mNotificationManager.notify(1, mBuilder.build());
			
		}
		return Service.START_STICKY;
	}
	
	
}
