package com.org.controladoralimentos;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

 public class AlimentosAdapter extends BaseAdapter{
	ArrayList<String> names, dates;
	SQLiteHelper dbHelper;
	Context context;

    public AlimentosAdapter(ArrayList<String> names, ArrayList<String> dates, Context context) {
    	this.names = names;
    	this.dates = dates;
    	dbHelper = new SQLiteHelper(context);
    	this.context = context;
    }

	public int getCount() {
		return names.size();
	}

	public Object getItem(int arg0) {
		return null;
	}

	public long getItemId(int position) {
		return position;
	}

	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder holder = null;
		View vi = convertView;
		if(convertView == null){
			LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			vi = inflater.inflate(R.layout.list_item, parent, false);
			holder = new ViewHolder();
            holder.name = (TextView) vi.findViewById(R.id.textViewListName);
            holder.date = (TextView) vi.findViewById(R.id.textViewListDate);
            holder.cook = (ImageButton)vi.findViewById(R.id.imageButtonCocinar);
            holder.delete = (ImageButton)vi.findViewById(R.id.imageButtonBorrar);
            vi.setTag(holder);
          
		}else{
			holder = (ViewHolder) vi.getTag();
		}
		holder.name.setText(names.get(position));
		holder.date.setText(dates.get(position));

		holder.delete.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				LinearLayout row=(LinearLayout) v.getParent().getParent();
    			final TextView txtName = (TextView)row.findViewById(R.id.textViewListName);
				AlertDialog.Builder builder = new AlertDialog.Builder(context);
				builder
				.setMessage("Eliminar el alimento?")
				.setPositiveButton("Aceptar", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						int result = dbHelper.deleteAlimento(txtName.getText().toString());
						if(result==1){
							Toast.makeText(context, "Alimento eliminado correctamente", Toast.LENGTH_SHORT).show();
							names.remove(position);
							dates.remove(position);
							notifyDataSetChanged();
						}else{
							Toast.makeText(context, "Error al eliminar aliimento", Toast.LENGTH_SHORT).show();
						}
					}
				})
				.setNegativeButton("Cancelar", null)
				.setTitle("Controlador Alimentos")
				.show();

			}
		});
		
		holder.cook.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				LinearLayout row=(LinearLayout) v.getParent().getParent();
    			final TextView txtName = (TextView)row.findViewById(R.id.textViewListName);
    			LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				View dialogView = inflater.inflate(R.layout.buscador_dialog, null);
				final EditText editPlate = (EditText) dialogView.findViewById(R.id.editTextIngredientes);
    			AlertDialog.Builder builder = new AlertDialog.Builder(context);
				builder
				.setView(dialogView)
				.setMessage("Añada ingredientes a la receta")
				.setPositiveButton("Aceptar", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						String query = "receta "+ txtName.getText().toString() + " "+editPlate.getText().toString();
						Uri uri = Uri.parse("http://www.google.com/#q="+query);
						Intent intent = new Intent(Intent.ACTION_VIEW, uri);
						context.startActivity(intent);
					}
				})
				.setNegativeButton("Cancelar", null)
				.setTitle("Controlador Alimentos")
				.show();
			}
		});

		return (vi);
	}

}
 class ViewHolder{
	TextView name;
	TextView date;
    ImageButton cook;
    ImageButton delete;
}
