package com.org.controladoralimentos;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Locale;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

/**
 * A simple {@link Fragment} subclass.
 * 
 */
public class Historico extends Fragment {

	private static final String ARG_SECTION_NUMBER = "section_number";
	private Spinner spnAlimentos;
	private TextView txtNombre;
	private TextView txtCodigo;
	private ImageButton btnScan;
	private SQLiteHelper dbHelper;
	private Button btnSave;
	private EditText editDate;
	private Calendar mycalendar = Calendar.getInstance();
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		dbHelper = new SQLiteHelper(getActivity());
	}

	public Historico() {
		// Required empty public constructor
	}
	
	/**
    * Returns a new instance of this fragment for the given section
    * number.
    */
   public static Historico newInstance(int sectionNumber) {
	   Historico fragment = new Historico();
       Bundle args = new Bundle();
       args.putInt(ARG_SECTION_NUMBER, sectionNumber);
       fragment.setArguments(args);
       return fragment;
   }


	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// Inflate the layout for this fragment
		View rootView = inflater.inflate(R.layout.fragment_historico, container, false);
		spnAlimentos = (Spinner)rootView.findViewById(R.id.spinnerHistorico);
		txtCodigo = (TextView)rootView.findViewById(R.id.textViewName);
		txtNombre = (TextView)rootView.findViewById(R.id.textViewCodigo);
		btnScan =(ImageButton)rootView.findViewById(R.id.imageButtonScan);
		btnScan.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				scan();				
			}
		});
		btnSave = (Button)rootView.findViewById(R.id.buttonGuardar);
		btnSave.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				String text;
				if(!txtNombre.getText().toString().isEmpty()){
					text = txtNombre.getText().toString();
				}else{
					text=spnAlimentos.getSelectedItem().toString();
				}
				 int res = dbHelper.guardarAlimentoActual(text, mycalendar.getTimeInMillis(), txtCodigo.getText().toString());
				    if(res == 1){
				    	Toast.makeText(getActivity(), "Alimento añadido correctamente", Toast.LENGTH_SHORT).show();
				    }else{
				    	Toast.makeText(getActivity(), "Error, ya existe un alimento con ese nombre", Toast.LENGTH_SHORT).show();
				    }	
				
			}
		});
		editDate = (EditText)rootView.findViewById(R.id.EditTextDate);
		final DatePickerDialog.OnDateSetListener date = new DatePickerDialog.OnDateSetListener() {

        	public void onDateSet(DatePicker view, int year, int monthOfYear,
        			int dayOfMonth) {
        		mycalendar.set(Calendar.YEAR, year);
        		mycalendar.set(Calendar.MONTH, monthOfYear);
        		mycalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
        		updateLabel();

        	}
        };
        editDate.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
					new DatePickerDialog(getActivity(), date, mycalendar.get(Calendar.YEAR), mycalendar.get(Calendar.MONTH),mycalendar.get(Calendar.DAY_OF_MONTH)).show();
			}
		});
        reloadSpinner();
		return rootView;
	}
	
	private void updateLabel() {

		String myFormat = "dd/MM/yyyy"; //In which you need put here
		SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.getDefault());

		editDate.setText(sdf.format(mycalendar.getTime()));
	}

	public void reloadSpinner(){
		if(dbHelper != null && spnAlimentos != null){
			ArrayList<String> arrayAlimentos = dbHelper.getHistoricoAlimentos();
			if(arrayAlimentos != null){
				ArrayAdapter<String> adapter =new ArrayAdapter<String>(getActivity(),
		                android.R.layout.simple_spinner_item, arrayAlimentos);
				adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
				spnAlimentos.setAdapter(adapter);
			}		
		}
		
	}

	@Override
	public void setUserVisibleHint(boolean isVisibleToUser) {
	    super.setUserVisibleHint(isVisibleToUser);
	    if (isVisibleToUser) { 
	    	reloadSpinner();
	    }
	    else {  }
	}
	
	 public void scan(){
			IntentIntegrator integrator = new IntentIntegrator(this);
			integrator.initiateScan();
	    }
	    
	    public void onActivityResult(int requestCode, int resultCode, Intent intent) {
	  	  IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
	  	  if (scanResult != null) {	 
	  		  txtCodigo.setText(scanResult.getContents());
	  		  txtNombre.setText(dbHelper.obtenerPorCodigo(scanResult.getContents()));
	  	  }
	  	}
}
