package com.org.controladoralimentos;

import java.util.ArrayList;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;

public class ListaFragment extends Fragment {
	private static final String ARG_SECTION_NUMBER = "section_number";
	private ListView lstAlimentos;
	private SQLiteHelper dbHelper;
	private ArrayList<String> nombres;
	private ArrayList<String> fechas;
	
	 /**
     * Returns a new instance of this fragment for the given section
     * number.
     */
    public static ListaFragment newInstance(int sectionNumber) {
    	ListaFragment fragment = new ListaFragment();
        Bundle args = new Bundle();
        args.putInt(ARG_SECTION_NUMBER, sectionNumber);
        fragment.setArguments(args);
        
        return fragment;
    }

    public ListaFragment() {
    }

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		dbHelper = new SQLiteHelper(getActivity());
		View rootView = inflater.inflate(R.layout.fragment_lista, container, false);
		lstAlimentos = (ListView)rootView.findViewById(R.id.listViewAlimentos);
		ArrayList<String[]> alimentos = dbHelper.getActualAlimentos();
		nombres = new ArrayList<String>();
		fechas = new ArrayList<String>();
		for(int i = 0;i<alimentos.size();i++){
			nombres.add(alimentos.get(i)[0]);
			fechas.add(alimentos.get(i)[1]);
			
		}
    	lstAlimentos.setAdapter(new AlimentosAdapter(nombres, fechas, getActivity()));
		
		
		return rootView;
	}

    
	@Override
	public void setUserVisibleHint(boolean isVisibleToUser) {
	    super.setUserVisibleHint(isVisibleToUser);
	    if (isVisibleToUser) {
	    	if(dbHelper == null)
	    		dbHelper = new SQLiteHelper(getActivity());
	    	if(lstAlimentos != null){
	    		ArrayList<String[]> alimentos = dbHelper.getActualAlimentos();
				nombres = new ArrayList<String>();
				fechas = new ArrayList<String>();
				for(int i = 0;i<alimentos.size();i++){
					nombres.add(alimentos.get(i)[0]);
					fechas.add(alimentos.get(i)[1]);
					
				}
		    	lstAlimentos.setAdapter(new AlimentosAdapter(nombres, fechas, getActivity()));
	    	}
	    	
	    }
	    else {  }
	}
	

}
