package com.org.controladoralimentos;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Locale;

import android.app.DatePickerDialog;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

/**
 * A placeholder fragment containing a simple view.
 */
public class MainFragment extends Fragment {
    /**
     * The fragment argument representing the section number for this
     * fragment.
     */
	private ImageButton btnScan;
    private static final String ARG_SECTION_NUMBER = "section_number";
    private SQLiteHelper dbHelper;
    private Button save;
    private EditText txtName;
    private TextView txtCodigo;
    private EditText editDate;
    private Calendar mycalendar = Calendar.getInstance();

    /**
     * Returns a new instance of this fragment for the given section
     * number.
     */
    public static MainFragment newInstance(int sectionNumber) {
    	MainFragment fragment = new MainFragment();
        Bundle args = new Bundle();
        args.putInt(ARG_SECTION_NUMBER, sectionNumber);
        fragment.setArguments(args);
        return fragment;
    }

    public MainFragment() {
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_main, container, false);
        editDate = (EditText)rootView.findViewById(R.id.editTextFecha);
        editDate.setFocusable(false);
        txtName =(EditText)rootView.findViewById(R.id.editTextNombre);
        txtCodigo = (TextView)rootView.findViewById(R.id.textViewCodigoBarras);
        dbHelper = new SQLiteHelper(getActivity());
        btnScan = (ImageButton)rootView.findViewById(R.id.imageButton1);
        btnScan.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				((MainActivity)getActivity()).scan(txtCodigo);
				
			}
		});
        save = (Button)rootView.findViewById(R.id.buttonGuardar);
        save.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				if(!editDate.getText().toString().isEmpty() && !txtName.getText().toString().isEmpty()){
					dbHelper.guardarAlimentoHistorico(txtName.getText().toString(), mycalendar.getTimeInMillis(), txtCodigo.getText().toString());
				    
				    int res = dbHelper.guardarAlimentoActual(txtName.getText().toString(), mycalendar.getTimeInMillis(), txtCodigo.getText().toString());
				    if(res == 1){
				    	Toast.makeText(getActivity(), "Alimento añadido correctamente", Toast.LENGTH_SHORT).show();
				    }else{
				    	Toast.makeText(getActivity(), "Error, ya existe un alimento con ese nombre", Toast.LENGTH_SHORT).show();
				    }	
				}else{
					if(editDate.getText().toString().isEmpty())
						editDate.setError("No puede estar vacío");
					if(txtName.getText().toString().isEmpty())	
						txtName.setError("No puede estar vacío");
				}
			    		
			}
        });

        final 

        DatePickerDialog.OnDateSetListener date = new DatePickerDialog.OnDateSetListener() {

        	public void onDateSet(DatePicker view, int year, int monthOfYear,
        			int dayOfMonth) {
        		mycalendar.set(Calendar.YEAR, year);
        		mycalendar.set(Calendar.MONTH, monthOfYear);
        		mycalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
        		updateLabel();

        	}
        };
        editDate.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
					new DatePickerDialog(getActivity(), date, mycalendar.get(Calendar.YEAR), mycalendar.get(Calendar.MONTH),mycalendar.get(Calendar.DAY_OF_MONTH)).show();
			}
		});
        return rootView;
    }
    
    private void updateLabel() {

		String myFormat = "dd/MM/yyyy"; //In which you need put here
		SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.getDefault());

		editDate.setText(sdf.format(mycalendar.getTime()));
	}
    
    public void changeText(String text){
    	/*View v = getView();
    	TextView t = (TextView)getView().findViewById(R.id.textViewCodigoBarras)*/
    	txtCodigo.setText(text);
    }
    
}
