package com.org.controladoralimentos;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.MapsInitializer;
import com.google.android.gms.maps.GoogleMap.OnMapClickListener;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

import android.app.ProgressDialog;
import android.content.SharedPreferences;
import android.location.Location;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

public class MapaFragment extends Fragment  implements OnMapClickListener{
	private static final String ARG_SECTION_NUMBER = "section_number";
	private static final String DEBUG_MSG = "Controlador alimentos";
	private ArrayList<String> names;
	private ArrayList<Double> latitudes;
	private ArrayList<Double> longitudes;

	MapView mMapView;
	private GoogleMap mapa;
	public MapaFragment() {
		// Required empty public constructor
	}

	/**
	    * Returns a new instance of this fragment for the given section
	    * number.
	    */
	   public static MapaFragment newInstance(int sectionNumber) {
		   MapaFragment fragment = new MapaFragment();
	       Bundle args = new Bundle();
	       args.putInt(ARG_SECTION_NUMBER, sectionNumber);
	       fragment.setArguments(args);
	       return fragment;
	   }

	   @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container,
			   Bundle savedInstanceState) {

		  
		   names = new ArrayList<String>();
		   latitudes = new ArrayList<Double>();
		   longitudes = new ArrayList<Double>();
		   // Inflate the layout for this fragment
		   View rootView = inflater.inflate(R.layout.mapa_fragment, container, false);
		   mMapView = (MapView) rootView.findViewById(R.id.mapView);
		   mMapView.onCreate(savedInstanceState);

		   mMapView.onResume();// needed to get the map to display immediately
		   try {
			   MapsInitializer.initialize(getActivity().getApplicationContext());
		   } catch (Exception e) {
			   e.printStackTrace();
		   }
		   mapa =  mMapView.getMap();
		   mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		   // map is a GoogleMap object
		   mapa.setMyLocationEnabled(true);

		   mapa.setMyLocationEnabled(true);
		   mapa.getUiSettings().setZoomControlsEnabled(false);
		   mapa.getUiSettings().setCompassEnabled(true);

		  
		  

		   
		   return rootView;
	   }

	   @Override
	   public void setUserVisibleHint(boolean isVisibleToUser) {
		   super.setUserVisibleHint(isVisibleToUser);
		   if (isVisibleToUser) { 
			   new getPlacesAsync().execute();
			   Location location = ((MainActivity)getActivity()).getMyLocation();
			   LatLng myposition = new LatLng(location.getLatitude(), location.getLongitude());
			   mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(myposition, 14));
		   }
		   else {  }
	   }

	   private class getPlacesAsync extends AsyncTask<Void, Void, ArrayList<Location>>{
			
		   ProgressDialog pd ;
			
			@Override
			protected void onPreExecute() {
				pd = ProgressDialog.show(getActivity(),null,"Obteniendo lugares...",true, false); 
			}

			@Override
			protected ArrayList<Location> doInBackground(Void... params) { 
				JSONArray obArrayResult = findPlaces();
				try {
					JSONObject obResult =obArrayResult.getJSONObject(0);
					JSONArray results = obResult.getJSONArray("results");
					for(int i=0;i< results.length();i++){
						JSONObject obJsonPlace = (JSONObject) results.get(i);
						latitudes.add(obJsonPlace.getJSONObject("geometry").getJSONObject("location").getDouble("lat"));
						longitudes.add(obJsonPlace.getJSONObject("geometry").getJSONObject("location").getDouble("lng"));
						names.add(obJsonPlace.getString("name"));
					}
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				return null;
			}


			@Override
			protected void onPostExecute(ArrayList<Location> locations) {
				pd.dismiss();	
				if(names.size()>0){
					for(int i=0;i<names.size();i++){
						mapa.addMarker(new MarkerOptions().position(new LatLng(latitudes.get(i), longitudes.get(i))).title(names.get(i)));
					}
				}else{
					Toast.makeText(getActivity(), "No se han encontrado lugares cercanoa", Toast.LENGTH_SHORT).show();
				}
				
			}

			
		}
	   
	   public JSONArray findPlaces()
	    {
		   JSONArray obResult = null;
	    	String result = "";
	    	InputStream is = null;
	    	Location location = ((MainActivity)getActivity()).getMyLocation();
	    	String latitude = Double.toString(location.getLatitude());
	    	String longitude = Double.toString(location.getLongitude());
	    	try {

	    		SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(getActivity());
	    		String dist = prefs.getString("distancia", "2000");
	    		BasicNameValuePair key = new BasicNameValuePair("key","AIzaSyCuGTza0XrakZtybz3U-AJKQyuuQAFLUk4");
	    		ArrayList<BasicNameValuePair> lstParams = new ArrayList<BasicNameValuePair>();
	    		lstParams.add(key);
	    		lstParams.add(new BasicNameValuePair("location", latitude+","+longitude));
	    		lstParams.add(new BasicNameValuePair("radius", "2000"));
	    		lstParams.add(new BasicNameValuePair("sensor", "false"));
	    		lstParams.add(new BasicNameValuePair("language", "es"));
	    		lstParams.add(new BasicNameValuePair("types", "grocery_or_supermarket"));

	    		//HTTP post message
	    		HttpClient obHttpClient = new DefaultHttpClient();
	    		StringBuilder query = new StringBuilder();
	    		query.append("https://maps.googleapis.com/maps/api/place/nearbysearch/json?");
	    		query.append("location=" +  latitude + "," + longitude + "&");
	    		query.append("radius=" + dist + "&");
	    		query.append("types=" + "grocery_or_supermarket" + "&");
	    		query.append("sensor=true&"); //Must be true if queried from a device with GPS
	    		query.append("key=" + "AIzaSyCuGTza0XrakZtybz3U-AJKQyuuQAFLUk4");
	    		HttpResponse response = obHttpClient.execute(new HttpGet(query.toString()));

	    		HttpEntity entity = response.getEntity();
	    		is = entity.getContent();
	    	}
	    	catch(Exception e)
	    	{
	    		Log.e(DEBUG_MSG, "Login::HTTP connection error: " + e.toString());
	    	}
	    	//Convert response to string
	    	try
	    	{
	    		BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
	    		StringBuilder sb = new StringBuilder();
	    		String line = null;

	    		while ((line = reader.readLine()) != null) 
	    		{
	    			sb.append(line + "\n");
	    		}

	    		is.close();
	    		result = sb.toString();	
	    		//Check brackets
	    		if(!result.startsWith("[") && !result.endsWith("]"))
	    		{
	    			result = "[" + result + "]";
	    		}	

	    	}
	    	catch(Exception e)
	    	{
	    		Log.e(DEBUG_MSG, "Login::Error converting result: " + e.toString());
	    	}

	    	//Parse json data
	    	try
	    	{
	    		obResult = new JSONArray(result);
	    	}
	    	catch(JSONException e)
	    	{
	    		Log.e(DEBUG_MSG, "ini::Error parsing JSON data: " + e.toString());
	    	}

	    	return obResult;
	    }

	@Override
	public void onMapClick(LatLng point) {
		// TODO Auto-generated method stub
		
	}

}
