package com.org.controladoralimentos;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

import android.content.Context;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.preference.PreferenceManager;

public class SQLiteHelper extends SQLiteOpenHelper {

	Long maxDiff ;
	private static Context ctx;
	public SQLiteHelper(Context context) {
		super(context, "ControladorAlimentos", null, 1);
		this.ctx = context;
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL("Create TABLE actual (name TEXT PRIMARY KEY,date LONG, barcode TEXT)");
		db.execSQL("Create TABLE historico (name TEXT PRIMARY KEY,date LONG, barcode TEXT)");
		
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub
		
	}
	
	public void guardarAlimentoHistorico(String nombre, long fechaCaducidad, String codigo ){
		try {
			SQLiteDatabase db = getWritableDatabase();
			db.execSQL("INSERT INTO historico VALUES ('"+nombre+"' ,"+fechaCaducidad+",'"+codigo+"')");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		
	}
	
	public int guardarAlimentoActual(String nombre, long fechaCaducidad, String codigo) {
		try {
			SQLiteDatabase db = getWritableDatabase();
			db.execSQL("INSERT INTO actual VALUES ('"+nombre+"' ,"+fechaCaducidad+",'"+codigo+"')");
			return 1;
		} catch (SQLException e) {
			
			e.printStackTrace();
			return 0;
		}
	}
	
	public ArrayList<String> getHistoricoAlimentos(){
		ArrayList<String> alimentos = new ArrayList<String>();
		try {
			SQLiteDatabase db = getWritableDatabase();
			Cursor c =  db.rawQuery("SELECT name FROM historico",null);
			while(c.moveToNext()){
				alimentos.add(c.getString(0));
			}
			c.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return alimentos;
	}
	
	public ArrayList<String []> getActualAlimentos(){
		
		ArrayList<String[]> alimentos = new ArrayList<String[]>();
		SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy", Locale.getDefault());
		Date date;
		try {
			SQLiteDatabase db = getWritableDatabase();
			Cursor c =  db.rawQuery("SELECT name,date FROM actual ORDER BY date ASC",null);
			while(c.moveToNext()){
				String[] alimento = new String[2];
				Long l = Long.parseLong(c.getString(1));
				alimento[0]= c.getString(0);
				date = new Date(l);			
				alimento[1] = format.format(date);
				alimentos.add(alimento);
			}
			c.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return alimentos;
	}
	public int deleteAlimento(String name){
		try {
			SQLiteDatabase db = getWritableDatabase();
			db.execSQL("DELETE FROM actual WHERE name ='"+name+"'");
			return 1;
		} catch (SQLException e) {
			
			e.printStackTrace();
			return 0;
		}
	}
	
	public String obtenerPorCodigo(String codigo){
		String nombre = "";
		try {
		SQLiteDatabase db = getWritableDatabase();
		Cursor c =  db.rawQuery("SELECT name FROM historico WHERE barcode = '"+codigo+"'",null);
		while(c.moveToNext()){
		
			nombre  = c.getString(0);
			
		}
		c.close();
	} catch (SQLException e) {
		e.printStackTrace();
	}
	return nombre;
	}

	public boolean obtenerCaducables(){
		try {
			SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(ctx);
			int dias = Integer.parseInt(prefs.getString("dias", "1"));
			this.maxDiff = (long) (3600*dias*24*1000);
			SQLiteDatabase db = getWritableDatabase();
			Cursor c =  db.rawQuery("SELECT date FROM actual",null);
			while(c.moveToNext()){
				Calendar cal = Calendar.getInstance();
				Long  date = Long.parseLong(c.getString(0));
				Long diff = date-cal.getTimeInMillis() ;
				if(diff<this.maxDiff)
				return true;
				
			}
			c.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return false;
	}
}
