package com.org.controladoralimentos;

import java.util.Locale;

import android.content.Context;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;

/**
 * A {@link FragmentPagerAdapter} that returns a fragment corresponding to
 * one of the sections/tabs/pages.
 */
public class SectionsPagerAdapter extends FragmentPagerAdapter {

	private Context context;
	private ViewPager container;
	
    public SectionsPagerAdapter(FragmentManager fm,Context ctx,ViewPager vp ) {
        super(fm);
        this.context = ctx;
        this.container = vp;
    }

    @Override
    public Fragment getItem(int position) {
    	// getItem is called to instantiate the fragment for the given page.
    	// Return a PlaceholderFragment (defined as a static inner class below).
    	switch(position){
    	case 0:
    		return MainFragment.newInstance(position + 1);
    	case 1:
    		return Historico.newInstance(position + 1);
    	case 2:
    		return ListaFragment.newInstance(position + 1);
    	case 3:
    		return MapaFragment.newInstance(position + 1);
    	default:
    		return MainFragment.newInstance(position + 1);
    	}


    }

    @Override
    public int getCount() {
        // Show 3 total pages.
        return 4;
    }

    @Override
    public CharSequence getPageTitle(int position) {
        Locale l = Locale.getDefault();
        switch (position) {
            case 0:
                return "NUEVO";
            case 1:
                return "AÑADIR DESDE HISTÓRICO";
            case 2:
                return "CONSUMIR";
            case 3:
                return "COMPRAR";
        }
        return null;
    }

}
